CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

   DO  = 16      'Set these pins to match your SD connections.
   CLK = 17
   DI  = 18
   CS  = 19

  SPRX = 0
  SPRY = 1
  SPRP = 2
  SPRC = 3

VAR

  long  PropGFXInserted    
  
OBJ
  Lite     : "GFX_BINARY_Databus"
  sdfat    : "fsrw"
    STR    : "STRINGS"  
PUB Main | i,ocnt

  sdfat.mount_explicit(DO, CLK, DI, CS)
   
  Lite.PropGFX_Start
  if(Lite.PropGFX_TestValid==0)
    reboot

  do_demo


PUB do_demo 


  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_4BIT_CHAR_MODE,Lite#PROPGFX_0_SCROLL_COGS,0,Lite#PROPGFX_NORMAL_SPRITES) ' mode+8 = SEPERATE CHAR LINE X SCROLLS                                                                                                           

  repeat
    imageload(string("gracey"))
    RunMarioRun
    imageload(string("propchip"))
    waitcnt(clkfreq *4 +cnt)
    imageload(string("ghostb"))
    RunMarioRun
    imageload(string("ppdb"))
    waitcnt(clkfreq *4 +cnt)
    imageload(string("saucerb"))
    RunMarioRun
    imageload(string("protob"))
    waitcnt(clkfreq *4 +cnt)
     
PUB RunMarioRun | i,x,y 

  Lite.Set16ColourSprites
  Lite.sendbuf(@sprite_images,$7000,4096)                 ' Copy sprite data to free memory location
  Lite.sendbuf(@sprite_pal,$1700,$100) ' Copy sprite palette data to reserved memory location
  Lite.pokeword(Lite#PROPGFX_SPRCHRPTR,$7000)   

  x := 0
  y := 0
  Repeat 12
    
    Repeat i from 0 to 3
     
      Lite.SetSprite(2,x,y+160,0,i*2)
      Lite.SetSprite(3,x,y+175,0,(i*2)+64)
      
      x+=5
      if x > 256
       x:= -16
      waitcnt(clkfreq/15+cnt)

  Lite.SetSprite(2,-50,-50,0,0)
  Lite.SetSprite(3,-50,-50,0,0)
    
PUB imageload (image) | i,r,chr,map,pal,filename



  chr:=string(".chr")
  pal:=string(".pal")
  map:=string(".map")
  
  '' load .chr into PropGFX memory
  filename:=str.Combine (image,chr)
  sdfat.popen(filename,"r")
  i:=0
  repeat                 
    r := sdfat.pgetc      
      if r < 0  
         quit
                      
    lite.PokeByte($2000+i,r)
    i++
  sdfat.pclose

  '' load .map into PropGFX memory
  filename:=str.Combine (image,map) 
  sdfat.popen(filename,"r")
  i:=0
  repeat                 
    r := sdfat.pgetc      
      if r < 0  
         quit
                      
    lite.PokeByte($1800+i,r)
    i++
  sdfat.pclose

  '' Load .pal into PropGFX memory
  filename:=str.Combine (image,pal) 
  sdfat.popen(filename,"r")
  i:=0
  repeat                 
    r := sdfat.pgetc      
      if r < 0  
         quit
                      
    lite.PokeByte($1600+i,r)
    i++
  sdfat.pclose

DAT
sprite_images  file      "mariospr.chr"
sprite_pal     file      "mariospr.pal"